/* ***********************************************************
 * This file was automatically generated on 2016-06-30.      *
 *                                                           *
 * Mathematica Bindings Version 2.1.9                        *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Measures reflectivity of a surface
	/// </summary>
	public class BrickletLine : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 241;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Line Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_REFLECTIVITY = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_REFLECTIVITY_CALLBACK_PERIOD = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_REFLECTIVITY_CALLBACK_PERIOD = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_REFLECTIVITY_CALLBACK_THRESHOLD = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_REFLECTIVITY_CALLBACK_THRESHOLD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte CALLBACK_REFLECTIVITY = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte CALLBACK_REFLECTIVITY_REACHED = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_GREATER = '>';


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletLine.SetReflectivityCallbackPeriod"/>. The parameter is the reflectivity
		///  of the sensor.
		///  
		///  <see cref="Tinkerforge.BrickletLine.Reflectivity"/> is only triggered if the reflectivity has changed since the
		///  last triggering.
		/// </summary>
		public event ReflectivityEventHandler Reflectivity;
		/// <summary>
		/// </summary>
		public delegate void ReflectivityEventHandler(BrickletLine sender, int reflectivity);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletLine.SetReflectivityCallbackThreshold"/> is reached.
		///  The parameter is the reflectivity of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletLine.SetDebouncePeriod"/>.
		/// </summary>
		public event ReflectivityReachedEventHandler ReflectivityReached;
		/// <summary>
		/// </summary>
		public delegate void ReflectivityReachedEventHandler(BrickletLine sender, int reflectivity);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletLine(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			this.apiVersion[0] = 2;
			this.apiVersion[1] = 0;
			this.apiVersion[2] = 0;
			callbackWrappers[CALLBACK_REFLECTIVITY] = new CallbackWrapper(OnReflectivity);
			callbackWrappers[CALLBACK_REFLECTIVITY_REACHED] = new CallbackWrapper(OnReflectivityReached);

			responseExpected[FUNCTION_GET_REFLECTIVITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_REFLECTIVITY_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_REFLECTIVITY_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_REFLECTIVITY_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_REFLECTIVITY_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[CALLBACK_REFLECTIVITY] = ResponseExpectedFlag.ALWAYS_FALSE;
			responseExpected[CALLBACK_REFLECTIVITY_REACHED] = ResponseExpectedFlag.ALWAYS_FALSE;
		}

		/// <summary>
		///  Returns the currently measured reflectivity. The reflectivity is
		///  a value between 0 (not reflective) and 4095 (very reflective).
		///  
		///  Usually black has a low reflectivity while white has a high
		///  reflectivity.
		///  
		///  If you want to get the reflectivity periodically, it is recommended 
		///  to use the callback <see cref="Tinkerforge.BrickletLine.Reflectivity"/> and set the period with 
		///  <see cref="Tinkerforge.BrickletLine.SetReflectivityCallbackPeriod"/>.
		/// </summary>
		public int GetReflectivity()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_REFLECTIVITY);

			byte[] response = SendRequest(request);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletLine.Reflectivity"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletLine.Reflectivity"/> is only triggered if the reflectivity has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetReflectivityCallbackPeriod(long period)
		{
			byte[] request = CreateRequestPacket(12, FUNCTION_SET_REFLECTIVITY_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletLine.SetReflectivityCallbackPeriod"/>.
		/// </summary>
		public long GetReflectivityCallbackPeriod()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_REFLECTIVITY_CALLBACK_PERIOD);

			byte[] response = SendRequest(request);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletLine.ReflectivityReached"/> callback. 
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the reflectivity is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the reflectivity is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the reflectivity is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the reflectivity is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetReflectivityCallbackThreshold(char option, int min, int max)
		{
			byte[] request = CreateRequestPacket(13, FUNCTION_SET_REFLECTIVITY_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((short)min, 9, request);
			LEConverter.To((short)max, 11, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletLine.SetReflectivityCallbackThreshold"/>.
		/// </summary>
		public void GetReflectivityCallbackThreshold(out char option, out int min, out int max)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_REFLECTIVITY_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.UShortFrom(9, response);
			max = LEConverter.UShortFrom(11, response);
		}

		/// <summary>
		///  Sets the period in ms with which the threshold callback
		///  
		///  * <see cref="Tinkerforge.BrickletLine.ReflectivityReached"/>
		///  
		///  is triggered, if the threshold
		///  
		///  * <see cref="Tinkerforge.BrickletLine.SetReflectivityCallbackThreshold"/>
		///  
		///  keeps being reached.
		///  
		///  The default value is 100.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletLine.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to, 
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnReflectivity(byte[] response)
		{
			int reflectivity = LEConverter.UShortFrom(8, response);

			var handler = Reflectivity;
			if(handler != null)
			{
				handler(this, reflectivity);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnReflectivityReached(byte[] response)
		{
			int reflectivity = LEConverter.UShortFrom(8, response);

			var handler = ReflectivityReached;
			if(handler != null)
			{
				handler(this, reflectivity);
			}
		}
	}
}
